module MainH where
import Control.Monad.IO.Class
import Control.Monad.Trans.State.Strict
import ESFA

-- Run the main test...
main =
  do separator_line
     runtree1

     separator_line
     putStrLn "runtree_parle"
     runtree_parle

     separator_line
     putStrLn "Single threaded array"
     runtree 4 run_single_threaded_array

     separator_line
     putStrLn "Multiple single threaded arrays"
     runtree 4 run_multiple_single_threaded_arrays

     separator_line
     putStrLn "Multiple single threaded arrays interleaved"
     runtree 4 run_multiple_single_threaded_arrays_interleaved

     separator_line
     putStrLn "main ending"

runtree1 :: IO ()
runtree1 = runtree 3 testtree1



testtree1 :: StateT TrStateTEST IO ()
testtree1 =
  do liftIO (putStrLn "testtree1")
     initNames
--     liftIO (putStrLn "Initial state")
--     tprintState

     a1 <- ptcUpdate "a1" (AName 0) (EltIndex 100, EltValue 101)
--     liftIO (putStrLn ("result = " ++ show a1))
--     tprintState

     a2 <- ptcUpdate "a2" (AName 0) (EltIndex 200, EltValue 201)
--     liftIO (putStrLn ("result = " ++ show a2))
--     tprintState

     a3 <- ptcUpdate "a2" (AName 0) (EltIndex 300, EltValue 301)
--     liftIO (putStrLn ("result = " ++ show a3))
     tprintState
